/**
 * Event Sourcing API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 *
 * @export
 * @interface EventMessage
 */
export interface EventMessage {
    /**
     * Unique identifier for the event
     * @type {string}
     * @memberof EventMessage
     */
    eventId: string;
    /**
     * ID of the entity (aggregate) that this event relates to
     * @type {string}
     * @memberof EventMessage
     */
    aggregateId: string;
    /**
     * Type of the aggregate, e.g., 'plugin', 'user', etc.
     * @type {string}
     * @memberof EventMessage
     */
    aggregateType?: string;
    /**
     * Version of the aggregate's state after this event
     * @type {number}
     * @memberof EventMessage
     */
    version: number;
    /**
     * Type of the event, e.g., 'PLUGIN_RUN', 'USER_ACTION'
     * @type {string}
     * @memberof EventMessage
     */
    eventType: string;
    /**
     * Version of the event schema
     * @type {string}
     * @memberof EventMessage
     */
    eventSchemaVersion: string;
    /**
     * Origin or source of the event, typically the service name
     * @type {string}
     * @memberof EventMessage
     */
    source: string;
    /**
     * ISO 8601 timestamp for when the event occurred
     * @type {Date}
     * @memberof EventMessage
     */
    timestamp: Date;
    /**
     * Data related to the event, this varies depending on event type
     * @type {{ [key: string]: any; }}
     * @memberof EventMessage
     */
    payload?: {
        [key: string]: any;
    } | null;
    /**
     * ID of the user initiating the event
     * @type {string}
     * @memberof EventMessage
     */
    userId?: string;
}
/**
 * Check if a given object implements the EventMessage interface.
 */
export declare function instanceOfEventMessage(value: object): value is EventMessage;
export declare function EventMessageFromJSON(json: any): EventMessage;
export declare function EventMessageFromJSONTyped(json: any, ignoreDiscriminator: boolean): EventMessage;
export declare function EventMessageToJSON(json: any): EventMessage;
export declare function EventMessageToJSONTyped(value?: EventMessage | null, ignoreDiscriminator?: boolean): any;
