/**
 * Plugin Management API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import type { PluginMetadataAuthor } from './PluginMetadataAuthor';
/**
 *
 * @export
 * @interface PluginMetadata
 */
export interface PluginMetadata {
    /**
     * Unique identifier for the plugin
     * @type {string}
     * @memberof PluginMetadata
     */
    id: string;
    /**
     * Version of the plugin, following semantic versioning
     * @type {string}
     * @memberof PluginMetadata
     */
    version: string;
    /**
     * Path to the main executable file for the plugin
     * @type {string}
     * @memberof PluginMetadata
     */
    executableFile: string;
    /**
     *
     * @type {PluginMetadataAuthor}
     * @memberof PluginMetadata
     */
    author: PluginMetadataAuthor;
    /**
     * Input validation schema for the plugin
     * @type {{ [key: string]: any; }}
     * @memberof PluginMetadata
     */
    inputs: {
        [key: string]: any;
    };
    /**
     * Expected output from the plugin
     * @type {{ [key: string]: any; }}
     * @memberof PluginMetadata
     */
    outputs?: {
        [key: string]: any;
    };
    /**
     * Brief description of the plugin's functionality
     * @type {string}
     * @memberof PluginMetadata
     */
    description: string;
    /**
     * The current status of the plugin
     * @type {string}
     * @memberof PluginMetadata
     */
    status: PluginMetadataStatusEnum;
    /**
     * Timestamp when the plugin was first created
     * @type {Date}
     * @memberof PluginMetadata
     */
    createdAt: Date;
    /**
     * Timestamp when the plugin was last updated
     * @type {Date}
     * @memberof PluginMetadata
     */
    updatedAt: Date;
    /**
     * Tags associated with the plugin for easy categorization
     * @type {Array<string>}
     * @memberof PluginMetadata
     */
    tags?: Array<string>;
    /**
     * URL of the thumbnail image
     * @type {string}
     * @memberof PluginMetadata
     */
    thumbnailUrl?: string;
    /**
     * List of URLs for additional images
     * @type {Array<string>}
     * @memberof PluginMetadata
     */
    imageUrls?: Array<string>;
}
/**
 * @export
 */
export declare const PluginMetadataStatusEnum: {
    readonly Active: "active";
    readonly Deprecated: "deprecated";
    readonly Pending: "pending";
};
export type PluginMetadataStatusEnum = typeof PluginMetadataStatusEnum[keyof typeof PluginMetadataStatusEnum];
/**
 * Check if a given object implements the PluginMetadata interface.
 */
export declare function instanceOfPluginMetadata(value: object): value is PluginMetadata;
export declare function PluginMetadataFromJSON(json: any): PluginMetadata;
export declare function PluginMetadataFromJSONTyped(json: any, ignoreDiscriminator: boolean): PluginMetadata;
export declare function PluginMetadataToJSON(json: any): PluginMetadata;
export declare function PluginMetadataToJSONTyped(value?: PluginMetadata | null, ignoreDiscriminator?: boolean): any;
