# openapi-client
No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0.0
- Package version: 1.0.0
- Generator version: 7.9.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.7+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import openapi_client
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import openapi_client
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import openapi_client
from openapi_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost
# See configuration.py for a list of all supported configuration parameters.
configuration = openapi_client.Configuration(
    host = "http://localhost"
)



# Enter a context with an instance of the API client
with openapi_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = openapi_client.DefaultApi(api_client)
    id = 'id_example' # str | 

    try:
        # Delete a plugin by ID
        api_instance.plugins_id_delete(id)
    except ApiException as e:
        print("Exception when calling DefaultApi->plugins_id_delete: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DefaultApi* | [**plugins_id_delete**](docs/DefaultApi.md#plugins_id_delete) | **DELETE** /plugins/{id} | Delete a plugin by ID
*DefaultApi* | [**plugins_id_get**](docs/DefaultApi.md#plugins_id_get) | **GET** /plugins/{id} | Get plugin metadata by ID
*DefaultApi* | [**plugins_id_images_filename_delete**](docs/DefaultApi.md#plugins_id_images_filename_delete) | **DELETE** /plugins/{id}/images/{filename} | Delete a specific image of a plugin
*DefaultApi* | [**plugins_id_images_get**](docs/DefaultApi.md#plugins_id_images_get) | **GET** /plugins/{id}/images | Get all images of a plugin
*DefaultApi* | [**plugins_id_images_post**](docs/DefaultApi.md#plugins_id_images_post) | **POST** /plugins/{id}/images | Upload multiple images for a plugin
*DefaultApi* | [**plugins_id_images_thumbnail_put**](docs/DefaultApi.md#plugins_id_images_thumbnail_put) | **PUT** /plugins/{id}/images/thumbnail | Set or update the thumbnail image for a plugin
*DefaultApi* | [**plugins_id_put**](docs/DefaultApi.md#plugins_id_put) | **PUT** /plugins/{id} | Update plugin metadata
*DefaultApi* | [**plugins_post**](docs/DefaultApi.md#plugins_post) | **POST** /plugins | Upload a new plugin


## Documentation For Models

 - [PluginMetadata](docs/PluginMetadata.md)
 - [PluginMetadataAuthor](docs/PluginMetadataAuthor.md)
 - [PluginsIdImagesGet200Response](docs/PluginsIdImagesGet200Response.md)
 - [PluginsIdImagesThumbnailPutRequest](docs/PluginsIdImagesThumbnailPutRequest.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization

Endpoints do not require authorization.


## Author




